
markup.push({

// MARK: app block

ApplicationSourceBlock:
{
	"+": "SourceTemplate",
	geNodeClass: "GEAppWrapperNode",
	geInputRank: 2,	
    h4PresetsId: "ApplicationPresets",
    gxTitle: "Application",
	gxNodeInitialProperties: { targetApplicationPath: "" },	// force recent app to be loaded
    gxLibraryDescription: "Capture audio from any application",
	gxLibraryIcon: "library.app.generic",
	gxDescriptionKeyPath: "node.appDisplayName",
	gxPopoverInfo: "ApplicationPopover",
	gxChildViews:
	[
		// drop view
		{
			nsClass: "GXDropView",
			gxValueKey: "node.droppedApps",
			acceptDroppedApps: true,
			gxFrameRect: "4,4,112,112",
			gxLayerZPosition: 2,
			gxHilitePainter: {
				"+": "DropHilitePainter",
				gxStrokeWidth: 5,
				gxCornerRadius: 14.5,
			},
		},
		// app icon
		{
			nsClass: "GXDrawView",
			gxForePainter: "ImagePainter.trimImage.block.app.select",
			gxValueKey: "node.appIcon",
			gxFrameRect: "20,36,80,48",
		},
		// app name
		{
			"+": "LabelView.centery.lineSquash1.foreColorTheme1.size105.wrap.useMarkup",
			gxValueKey: "node.appTitleMarkup",
			gxFrameRect: "11,84,98,28",
			axIsIgnored: true	// avoid VO reading title twice (blockDescription covers it)
		},
//		// badge
//		{
//			nsClass: "GXDrawView",
//			gxForePainter: "ImagePainter.colorThemeLive1.block.app.selectbadge",
//			gxShowOnKey: "node.hasNoTarget",
//            gxFrameRect: "20,35,80,42"
//		},
	]
},

// MARK: app popover

ApplicationPopover:
{
	"+": "PopoverTemplate",
	gxTitle: "Application Source",
	gxLayout: [	"H:|-12-[self(400)]-12-|",
				"V:|-12-[self]-12-|",
				"V:|-41-[group]-6-[presetsGroup]" ],
	gxChildViews:
	{
		title: "PopoverTitle",
		onOff: "PopoverOnOffSwitch",
		presetsGroup: presetsGroup("stripMarkup"),
		group:
		{
			"+": "GroupView",
			gxLayout: [
				"H:|-0-[self]-0-|",

				"H:|-13-[appPopup]-12-|",
				"H:|-13-[dropView]-12-|",

				"V:|-10-[groupTitle]",
				"V:|-35-[appPopup(42)]-10-[targetEnabled]-5-[targetUrl(26)]-12-[advancedBtn]-0-[advanced]-0-|",
				"V:|-35-[dropView(42)]",

				"H:|-12-[targetEnabled(100)]",
				"H:|-33-[targetUrlLabel]-8-[targetUrl]-12-|&alignBaseline",
			],
			gxChildViews:
			{
				groupTitle: groupTitleView("Source"),
				dropView: {
					nsClass: "GXDropView",
					gxValueKey: "node.droppedApps",
					acceptDroppedApps: true,
					gxLayerZPosition: 2,
					gxHilitePainter: {
						"+": "DropHilitePainter",
						gxCornerRadius: 7,
					},
				},
				appPopup: {
					nsClass: "GEAppPopupView",
					gxValueKey: "node.targetApplication",
					defaultAppIcon: "block.app.generic",
					gxIconPainter: {
						"+": "ImagePainter.trimImage.left",
						gxEdgeInsets: "12, 6, 0, 6",
					},
					gxBackPainter: "ControlBack",
					gxTitlePainter: "AppPopupMenuFore.useMarkup",
					gxArrowPainter: "ImagePainter.foreColor1.app.pulldown.arrow",
					axTitle: "Source Application",
					axHelp: "Choose an application source",
				},
				targetEnabled: {
					"+": "CheckboxTemplate",
					gxTitle: "<checkbox/> Open URL",
					gxValueKey: "node.targetURLEnabled",
					gxDisableOnKey: "running"
				},
				targetUrl: {
					"+": "DarkTextField",
					axTitle: "URL",
					gxValueKey: "node.targetURLString",
					gxPlaceholderString: "This URL will be opened when the session starts.",
					gxLineBreakMode: 0,	// word wrap
					gxDisableOnKey: "node.disableTargetURLField",
				},
                targetUrlLabel: labelView("URL:"),
                advancedBtn: {
                    "+": "AdvancedGroupButton",
                    gxTitle: "<disclosure/> Advanced",
					axFormatter: disclosureAxFormatter("Advanced"),
                    gxValueKey: "uiState.advancedExpanded"
                },
				advanced: {
					"+": "ExpandingGroupView.noTopStroke",
					gxValueKey: "uiState.advancedExpanded",
					gxCollapsible: true,
                    gxCollapsedSize: 1,
					gxExtraSize: 12,
					//axTitle: "Advanced Group",
					gxLayout: [	"H:|[self]|",
								"V:|-2-[captureInputs]-4-[text1(56)]-8-[splitChannels]-4-[text2(38)]-8-[continuousFlow]-4-[text3(30)]-8-[deviceEnabled]-6-[text4(18)]",
								"H:|-12-[captureInputs(150)]",
								"H:|-37-[text1]-15-|",
								"H:|-35-[splitChannels(170)]",
								"H:|-60-[text2]-13-|",
								"H:|-12-[continuousFlow(220)]",
								"H:|-37-[text3]-15-|",
								"H:|-12-[deviceEnabled(164)]-5-[device]-12-|&alignBaseline",
								"H:|-37-[text4]-15-|"  ],
					gxChildViews:
					{
						captureInputs: {
							"+": "CheckboxTemplate",
							gxTitle: "<checkbox/> Include audio input",
							gxValueKey: "node.captureInputs"
						},
						text1: {
							"+": "DescriptionLabelView",
							gxDefaultValue: "In addition to the standard capture of the application's audio output, audio from input devices like microphones will also be included. Use this setting to record both sides of a voice chat (VoIP) conversation."
						},
						splitChannels: {
							"+": "CheckboxTemplate",
							gxTitle: "<checkbox/> Split between channels",
							gxValueKey: "node.splitChannels",
							gxDisableOnKey: "node.disableSplitChannels"
						},
						text2: {
							"+": "DescriptionLabelView",
							gxDefaultValue: "Audio inputs will be placed on the left channel, while the application's audio output will be placed on the right channel."
						},
						continuousFlow: {
							"+": "CheckboxTemplate",
							gxTitle: "<checkbox/> Fill playback gaps with silence",
							gxValueKey: "node.continuousFlow"
						},
						text3: {
							"+": "DescriptionLabelView",
							gxDefaultValue: "If no audio is being played by the source application, silence will be generated and added."
						},
						deviceEnabled: {
							"+": "CheckboxTemplate",
							gxTitle: "<checkbox/> Limit audio capture to:",
							gxValueKey: "node.captureDeviceEnabled"
						},
						device: {
							"+": "PopupMenuTemplate",
							gxMenuItemsKeyPath: "node.captureDeviceMenuItems",
							gxValueKey: "node.captureDeviceIdentity",
							gxHideOnNilValue: false,
							gxDisableOnKey: "node.captureDeviceDisabled"
						},
						text4: {
							"+": "DescriptionLabelView",
							gxDefaultValue: "Only audio playing on the selected device will be captured."
						}
					}
				}
			}
		}
	}
},

AppPopupMenuFore: {
	"+": "LabelFore.left.size16",
	gxEdgeInsets: "52,0,2,0",
	gxFontColor: "ForeColor1",
	error: {
		gxFontColor: errorColor(99),
		disabled:     { gxFontColor: errorColor(40) }
	},

},

AppPopupMenuBack: {
	nsClass: "GXPainter",
	gxCornerRadius: 8,
	gxFillColor: "BackColor3",
},

})
